stages:
  - build
  - release

variables:
  CI_BUILD_IMAGE: "registry.gitlab.com/ericvh/docker-buildx-qemu"

.build:
  tags:
    - dind
    - docker
    - isr
  image: $CI_BUILD_IMAGE
  stage: build
  services:
    - name: docker:dind
      entrypoint: ["env", "-u", "DOCKER_HOST"]
      command: ["dockerd-entrypoint.sh"]
  variables:
    DOCKER_HOST: tcp://docker:2375/
    DOCKER_DRIVER: overlay2
    # See https://github.com/docker-library/docker/pull/166
    DOCKER_TLS_CERTDIR: ""
  retry: 2
  before_script:
    - |
      if [[ -z "$CI_COMMIT_TAG" ]]; then
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE/$CI_COMMIT_REF_SLUG}
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_SHA}
      else
        export CI_APPLICATION_REPOSITORY=${CI_APPLICATION_REPOSITORY:-$CI_REGISTRY_IMAGE}
        export CI_APPLICATION_TAG=${CI_APPLICATION_TAG:-$CI_COMMIT_TAG}
      fi
    - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY

build:buildx-arm64:
  stage: build
  extends: .build
  script:
    # Use docker-container driver to allow useful features (push/multi-platform)
    - update-binfmts --enable # Important: Ensures execution of other binary formats is enabled in the kernel
    - docker buildx create --driver docker-container --use
    - docker buildx inspect --bootstrap
    - docker buildx ls
    - docker buildx build --platform linux/arm64 -f Dockerfile --progress plain --pull -t ${CI_REGISTRY_IMAGE}-arm64 --load .
    - docker create --name build-image ${CI_REGISTRY_IMAGE}-arm64
    - mkdir -p $CI_COMMIT_REF_NAME/arm64
    - docker cp build-image:/tmp/extract $CI_COMMIT_REF_NAME/arm64
  
  # The files which are to be made available in GitLab
  artifacts:
    paths:
      - $CI_COMMIT_REF_NAME/arm64

build:buildx-arm:
  stage: build
  extends: .build
  script:
    # Use docker-container driver to allow useful features (push/multi-platform)
    - update-binfmts --enable # Important: Ensures execution of other binary formats is enabled in the kernel
    - docker buildx create --driver docker-container --use
    - docker buildx inspect --bootstrap
    - docker buildx ls
    - docker buildx build --platform linux/arm -f Dockerfile --progress plain --pull -t ${CI_REGISTRY_IMAGE}-arm --load .
    - docker create --name build-image ${CI_REGISTRY_IMAGE}-arm
    - mkdir -p $CI_COMMIT_REF_NAME/arm
    - docker cp build-image:/tmp/extract $CI_COMMIT_REF_NAME/arm
  
  # The files which are to be made available in GitLab
  artifacts:
    paths:
      - $CI_COMMIT_REF_NAME/arm

release_job:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  rules:
    - if: $CI_COMMIT_TAG                  # Run this job when a tag is created manually
  dependencies:
    - build:buildx-arm64
    - build:buildx-arm
  script:
    - > 
      release-cli create --name "$CI_COMMIT_TAG" 
      --description 'Created using the release-cli'
      --tag-name $CI_COMMIT_TAG
      --ref $CI_COMMIT_REF_NAME
      --assets-links-name "opencv4 arm64 buster deb package"
      --assets-links-url  https://gitlab.com/arm-research/smarter/smarter-opencv/-/jobs/$CI_JOB_ID/artifacts/raw/$CI_COMMIT_REF_NAME/arm64/extract/opencv4_4.4.0-1_arm64.deb
      --assets-links-name "opencv4 arm buster deb package"
      --assets-links-url  https://gitlab.com/arm-research/smarter/smarter-opencv/-/jobs/$CI_JOB_ID/artifacts/raw/$CI_COMMIT_REF_NAME/arm/extract/opencv4_4.4.0-1_armhf.deb

  artifacts:
    paths:
      - $CI_COMMIT_REF_NAME/arm64
      - $CI_COMMIT_REF_NAME/arm

